
//Functions.js
//fuctions for procesing logs
//cretaed by Jozef Palocko jpalocko@securitae.com

//global definitions
var XSL_ALL = "all.xslt";
var XSL_SBX = "sbx.xslt";
var XSL_FW = "fw.xslt";
var XSL_IDS = "ids.xslt";
var XSL_SYSTEM = "system.xslt";

//Create XML file  as a DOMDocument.
var xmlDoc = new ActiveXObject("Msxml2.DOMDocument.4.0");

var gModule = XSL_ALL;

function OnLoad()
{
	var d = new Date();              // Create Date object with today's date.
	var s = (d.getMonth() + 1) + "/";          // Get month
	s += d.getDate() + "/";                 // Get day
	s += d.getYear();         
	form.from.value = s;
	form.to.value =s;
	form.submit.value = DISPLAY;
}
function HandleMenu (id, str)
{
	var  title = TITLE_TEXT + " - " + str;
	document.all.top.innerHTML = title;
	switch (id)
	{
	case 0:
		gModule = XSL_ALL;break;
	case 1:
		gModule = XSL_SBX;break;
	case 2:
		gModule = XSL_FW;break;
	case 3:
		gModule = XSL_IDS;break;
	case 4:
		gModule = XSL_SYSTEM;break;
	}
}

function OnSubmit()
{
	if (CheckDates())
	{
		result.innerHTML =PLEASE_WAIT;

		var ret ="" ;
		dFrom = new Date(Date.parse(form.from.value));
		dTo= new Date( Date.parse(form.to.value));

		var d = dFrom;
		var strLogDir = GetLogDir();
		while( d<=dTo)
		{
			for (i=1;i<1000;i++)
			{
				var xml = strLogDir + GetFileName(d, i);
				//load  XML file as a DOMDocument.
				if (!xmlDoc.load(xml))
					continue;		
				while (xmlDoc.readyState<4);
				ret += TransformXML(xmlDoc);
			}
			d.setDate(d.getDate()+1);
		}
		if (ret=="")
			ret = NO_ENTRIES_STR;
		result.innerHTML = ret;
	}
}
function CheckDates()
{
	dFrom = Date.parse(form.from.value);
	dTo= Date.parse(form.to.value);
	if (!dFrom  || !dTo)
	{
		alert(ERR_DATE_FORMAT);
		return false;
	}
	if (dFrom>dTo)
	{
		alert(ERR_DATE_RANGE);
		return false;
	}
	return true;
}
function GetFileName(d, i)
{
	var strFile = new String;
	var tmp = new String;
	
	tmp += d.getYear();
	strFile += tmp.substr(2,2);
	
	tmp="";	tmp += d.getMonth() + 1;
	if (tmp.length ==1)
		tmp = "0" +tmp;
	strFile +=tmp;
	
	tmp="";tmp += d.getDate();
	if (tmp.length ==1)
		tmp = "0" +tmp;
	strFile += tmp;
	
	var index;
	if (i<10)
		index = "00"+i;
	else if(i<100)
		index = "0"+i;
	
	strFile += "_"+ index + ".xml";
	return strFile;
}
function GetLogDir()
{
	var xmlDoc = new ActiveXObject("Msxml2.DOMDocument.4.0");
	xmlDoc.async = false;
	xmlDoc.resolveExternals = false;
	xmlDoc.load("logcfg.xml");
	currNode = xmlDoc.selectSingleNode("//Logdir");
	strDir = currNode.text;
	var ch = strDir.charAt(strDir.length-1)
	if (ch !='\\')
		strDir+="\\";
	return strDir;
}

function TransformXML(xml, xsl)
{
	//load the stylesheet as a DOMDocument.
	var xslProc;

	//Create SAX writer.
	var xmlWriter = new ActiveXObject("Msxml2.MXXMLWriter.4.0");
	//Create the stylesheet as a DOMDocument.
	var xslDoc = new ActiveXObject("Msxml2.FreeThreadedDOMDocument.4.0");
	xslDoc.async = false;
	xslDoc.load(gModule);
	
	var xslt = new ActiveXObject("Msxml2.XSLTemplate.4.0");
	
	//Connect the XSLTemplate object to stylesheet DOMDocument.
	xslt.stylesheet = xslDoc;
	
	//Create XSLT processor using stylesheet for XSL template.
	xslProc = xslt.createProcessor();
	
	//Assign XML sample file as input of the transform() method.
	xslProc.input = xml;
	
	//Use a SAX writer as the output of the transform() method.
	xslProc.output = xmlWriter;
	
	//Do transformation on the sample XML file.
	xslProc.transform();

	//Use SAX writer ouptut 
	return  xmlWriter.output;
} 